// #############################################################
// Module Imports
// #############################################################
const { EmbedBuilder, WebhookClient } = require('discord.js');
const config = require('./config.json');
const dotenv = require('dotenv').config();

// #############################################################
// Variables
// #############################################################
const whInfo = {
    "topgg": {
        id: process.env.TOPGG_WH_ID,
        token: process.env.TOPGG_WH_TOKEN
    },
    "uptimeKuma": {
        id: process.env.UPTIMEKUMA_WH_ID,
        token: process.env.UPTIMEKUMA_WH_TOKEN
    },
    "testing": {
        id: process.env.TESTING_WH_ID,
        token: process.env.TESTING_WH_TOKEN
    }
}

module.exports = {
    testing() {
        // Create a new WebhookClient
        const webhookClient = new WebhookClient({ id: whInfo.testing.id, token: whInfo.testing.token });

        // Create a new EmbedBuilder
        const embed = new EmbedBuilder()
            .setTitle('Webhook Test')
            .setDescription('This is a test of the WebhookClient')
            .setTimestamp();

        // Send the Embed
        webhookClient.send({
            content: 'This is a test of the WebhookClient',
            username: config.discord.testing.username,
            embeds: [embed]
        });
    },
    topggVote(body) {
        // Create a new WebhookClient
        const webhookClient = new WebhookClient({ id: whInfo.topgg.id, token: whInfo.topgg.token });

        // Create a new EmbedBuilder
        const embed = new EmbedBuilder()
            .setTitle('Top.gg Vote')
            .setDescription(`<@${body.user}> voted for Silvanus on top.gg, thanks!\n\n[Vote Here](https://top.gg/bot/521624335119810561/vote)`)
            .setTimestamp();

        // Send the Embed
        webhookClient.send({
            username: config.discord.topgg.username,
            embeds: [embed]
        });
    },
    uptimeKumaAlert(body) {
        // Create a new WebhookClient
        const webhookClient = new WebhookClient({ id: whInfo.uptimeKuma.id, token: whInfo.uptimeKuma.token });

        // Create a new EmbedBuilder
        const state = body.heartbeat.status === 1 ? 'Up' : 'Down';
        const embed = new EmbedBuilder()
            .setTitle(`${body.monitor.name} Uptime Alert`)
            .setDescription(`State: ${state}\n\n${body.msg}`)
            .setTimestamp();

        // Send the Embed
        webhookClient.send({
            username: config.discord.uptimeKuma.username,
            embeds: [embed]
        });
    }
}