// #############################################################
// Module Imports
// #############################################################
const express = require('express');
const dotenv = require('dotenv');
const handlers = require('./Handlers.js');

// #############################################################
// Variables
// #############################################################
const port = 3000;
const locations = {
    "testing": "/hooks/testing",
    "topgg": "/hooks/vote",
    "uptimeKuma": "/hooks/uptime",
    "cp": "/cp"
};

// #############################################################
// Setup
// #############################################################
dotenv.config();
const app = express();
app.use(express.json());

// #############################################################
// Webhook Listeners
// #############################################################

// Testing Webhook
app.post(locations.testing, handlers.testing);

// Top.gg Votes
app.post(locations.topgg, handlers.topgg);

// Uptime Kuma Alerts
app.post(locations.uptimeKuma, handlers.uptimeKuma);

// Genertic Webhook
app.get('/webhook', handlers.testing);

// Top.gg Votes
app.get(locations.topgg, handlers.topgg);

// Uptime Kuma Alerts
app.get(locations.uptimeKuma, handlers.uptimeKuma);


// #############################################################
// Function Calls / Start Listening
// #############################################################
app.listen(port, () => {
    console.log(`Webhook server is running on port ${port}`);
});